<?php

defined("_JEXEC") or die('Restricted Access');
jimport('joomla.event.plugin');

class plgMassMail_filterResource extends JPlugin
{

	var $result = array();

	function plgMassMail_FilterResource(&$subject)
	{
		parent::__construct($subject);


	}

	function onRenderForm( $params = null)
	{
		$params = new JParameter($params);
		$text = new stdClass();

		$types = $this->getTypes();
		/*print "<pre>";
		print_r($types);
		print "</pre>";*/

		$options = array();
		foreach ($types as $val)
		{
			$options[] = JHTML::_('select.option', $val->id, $val->name);
		}
		$value_filter = $params->toArray();
		$value = @$value_filter['res::types'];
		$text->title = JText::_('JS Content userfilter by content type authors');
		$text->form = '

		<table class="admintable" cellspacing="1" width="100%">
			<tr>
				<td width="150" class="key">
					<label for="subscriptions">'.
		JText::_( 'Authors of a Content type' ).' :
					</label>
				</td>
				<td>
					'.JHTML::_('select.genericlist',  $options, 'value_filter[res::types][]', 'class="inputbox" MULTIPLE size="6"', 'value', 'text', $value, '' ).'
				</td>
			</tr>
		</table>';
		$ret [0] = clone($text);
		unset($options);


		$options = array();
		$categories = $this->getCategories();
		/*print "<pre>";
		print_r($categories);
		print "</pre>";*/

		foreach ($categories as $val)
		{
			$options[] = JHTML::_('select.option', $val->id, $val->name);
		}
		$value = @$value_filter['res::categories'];
		$text->title = JText::_('JS Content userfilter by category authors');
		$text->form = '
		<table class="admintable" cellspacing="1" width="100%">
			<tr>
				<td width="150" class="key">
					<label for="subscriptions">'.
		JText::_( 'Authors of categories' ).' :
					</label>
				</td>
				<td>
					'.JHTML::_('select.genericlist',  $options, 'value_filter[res::categories][]', 'class="inputbox" multiple="multiple" size="6"', 'value', 'text', $value, '' ).'
				</td>
			</tr>
		</table>';
		$ret[1] = clone($text);
		$value = @$value_filter['res::readers'];

		$text->title = JText::_('JS Content userfilter by category readers');
		$text->form = '
		<table class="admintable" cellspacing="1" width="100%">
			<tr>
				<td width="150" class="key">
					<label for="subscriptions">'.
		JText::_( 'Readers of categories' ).' :
					</label>
				</td>
				<td>
					'.JHTML::_('select.genericlist',  $options, 'value_filter[res::readers][]', 'class="inputbox" multiple="multiple" size="6"', 'value', 'text', $value, '' ).'
				</td>
			</tr>
		</table>';
		$ret[2] = clone($text);
		/*print "<pre>";
		print_r($ret);
		print "</pre>";
		exit;*/
		return $ret;
	}

	function onLeftJoin()
	{
		$value_filter = JRequest::getVar('value_filter', array());
		$types = @$value_filter['res::types'];
		$result = array();

		/*$result[] = " LEFT JOIN jos_js_res_hits AS reshits						 			 ON reshits.user_id = u.id";
		$result[] = " LEFT JOIN jos_js_res_record_category AS resreccatread  ON resreccatread.record_id = reshits.record_id";
		$result[] = " LEFT JOIN jos_js_res_category AS rescatread 			     ON rescatread.id = resreccatread.catid";
		$result[] = " LEFT JOIN jos_js_res_record AS resrecords 	    			 ON resrecords.user_id = u.id";
		$result[] = " LEFT JOIN jos_js_res_record_category AS resreccat      ON resreccat.record_id = resrecords.id";*/


		$result[] = " LEFT JOIN jos_js_res_record AS resrecords 	    			 ON resrecords.user_id = u.id";
		$result[] = " LEFT JOIN jos_js_res_record_category AS resreccat      ON resreccat.record_id = resrecords.id";
		if (count($types)>0)
		{
			//$ret[] =  "(  resrecords.type_id IN (".@implode(', ',$types).")) ";
			$result[] = " LEFT JOIN jos_js_res_types AS restypes 					 			 ON restypes.id = resrecords.type_id";
		}

		$categories = @$value_filter['res::categories'];
		if (count($categories)>0)
		{
			$result[] = " LEFT JOIN jos_js_res_category AS rescat 					     ON resreccat.catid = rescat.id";
		}
		$readers = @$value_filter['res::readers'];
		if (count($readers)>0)
		{
			$result[] = " LEFT JOIN jos_js_res_hits AS reshits						 			 ON reshits.user_id = u.id";
			$result[] = " LEFT JOIN jos_js_res_record_category AS resreccatread  ON resreccatread.record_id = reshits.record_id";
			$result[] = " LEFT JOIN jos_js_res_category AS rescatread 			     ON rescatread.id = resreccatread.catid";



		}




		return implode(" \n ", $result);
	}

	function onBuildWhere()
	{
		$ret = array();
		$value_filter = JRequest::getVar('value_filter', array());
		$types = @$value_filter['res::types'];
		if (count($types)>0)
		{
			$ret[] =  "(  resrecords.type_id IN (".@implode(', ',$types).")) ";
		}

		$categories = @$value_filter['res::categories'];
		if (count($categories)>0)
		{
			$ret[] = "( rescat.id IN (".@implode(', ',$categories)." ) )";
		}
		$readers = @$value_filter['res::readers'];
		if (count($readers)>0)
		{
			$ret[] = "( rescatread.id IN (".@implode(', ',$readers).") )";

		}
		return $ret;

	}

	function getTypes()
	{
		$db = &JFactory::getDBO();
		$query = "SELECT * "
		. "\n       FROM #__js_res_types  ";
		$db->setQuery($query);
		return $db->loadObjectList();
	}

	function getCategories()
	{
		$db = &JFactory::getDBO();
		$query = "SELECT * "
		. "\n       FROM #__js_res_category "
		. "\n   ORDER BY `ordering`"
		;
		$db->setQuery($query);
		return $db->loadObjectList();


	}

}
?>